using System;
using System.Collections.Generic;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Windows.Forms;

namespace ClientEmulator
{
    public class ClientEmulator : Form
    {
        private TcpClient tcpClient;
        private CheckBox chkConnect;
        private Label lblHost;
        private Label lblPort;
        private TextBox txtHost;
        private TextBox txtPort;
        private GroupBox grpConnected;

        public ClientEmulator()
        {
            InitializeComponent();
        }

        #region private void InitializeComponent()
        private void InitializeComponent()
        {
            this.chkConnect = new System.Windows.Forms.CheckBox();
            this.lblHost = new System.Windows.Forms.Label();
            this.lblPort = new System.Windows.Forms.Label();
            this.txtHost = new System.Windows.Forms.TextBox();
            this.txtPort = new System.Windows.Forms.TextBox();
            this.grpConnected = new System.Windows.Forms.GroupBox();
            this.SuspendLayout();
            // 
            // chkConnect
            // 
            this.chkConnect.Appearance = System.Windows.Forms.Appearance.Button;
            this.chkConnect.AutoSize = true;
            this.chkConnect.Location = new System.Drawing.Point(223, 27);
            this.chkConnect.MinimumSize = new System.Drawing.Size(57, 0);
            this.chkConnect.Name = "chkConnect";
            this.chkConnect.Size = new System.Drawing.Size(57, 22);
            this.chkConnect.TabIndex = 2;
            this.chkConnect.Text = "Connect";
            this.chkConnect.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            this.chkConnect.UseVisualStyleBackColor = true;
            this.chkConnect.CheckedChanged += new System.EventHandler(this.chkConnect_CheckedChanged);
            // 
            // lblHost
            // 
            this.lblHost.AutoSize = true;
            this.lblHost.Location = new System.Drawing.Point(12, 15);
            this.lblHost.Name = "lblHost";
            this.lblHost.Size = new System.Drawing.Size(130, 12);
            this.lblHost.TabIndex = 1;
            this.lblHost.Text = "Host (Name or Address)";
            // 
            // lblPort
            // 
            this.lblPort.AutoSize = true;
            this.lblPort.Location = new System.Drawing.Point(148, 14);
            this.lblPort.Name = "lblPort";
            this.lblPort.Size = new System.Drawing.Size(26, 12);
            this.lblPort.TabIndex = 2;
            this.lblPort.Text = "Port";
            // 
            // txtHost
            // 
            this.txtHost.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.txtHost.Location = new System.Drawing.Point(14, 30);
            this.txtHost.Name = "txtHost";
            this.txtHost.Size = new System.Drawing.Size(128, 19);
            this.txtHost.TabIndex = 0;
            this.txtHost.Text = "localhost";
            // 
            // txtPort
            // 
            this.txtPort.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.txtPort.Location = new System.Drawing.Point(148, 29);
            this.txtPort.MaxLength = 5;
            this.txtPort.Name = "txtPort";
            this.txtPort.Size = new System.Drawing.Size(42, 19);
            this.txtPort.TabIndex = 1;
            this.txtPort.Text = "65000";
            // 
            // grpConnected
            // 
            this.grpConnected.Enabled = false;
            this.grpConnected.Location = new System.Drawing.Point(12, 55);
            this.grpConnected.Name = "grpConnected";
            this.grpConnected.Size = new System.Drawing.Size(268, 199);
            this.grpConnected.TabIndex = 3;
            this.grpConnected.TabStop = false;
            this.grpConnected.Text = "ڑ";
            // 
            // ClientEmulator
            // 
            this.ClientSize = new System.Drawing.Size(292, 266);
            this.Controls.Add(this.grpConnected);
            this.Controls.Add(this.txtPort);
            this.Controls.Add(this.txtHost);
            this.Controls.Add(this.lblPort);
            this.Controls.Add(this.lblHost);
            this.Controls.Add(this.chkConnect);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.MaximizeBox = false;
            this.Name = "ClientEmulator";
            this.Text = "ClientEmulator";
            this.Load += new System.EventHandler(this.ClientEmulator_Load);
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        #endregion

        /// <summary>
        /// Form[h̏
        /// </summary>
        private void ClientEmulator_Load(object sender, EventArgs e)
        {
            chkConnect.Select();
        }

        /// <summary>
        /// ڑ^ؒf{^
        /// </summary>
        private void chkConnect_CheckedChanged(object sender, EventArgs e)
        {
            CheckBox cb = sender as CheckBox;
            bool enable = false;
            try
            {
                if (cb.Checked)
                {
                    // T[o[֐ڑ
                    connect();

                    // {^̖̑̂ɕύX
                    cb.Text = "Close";

                    // O[v^CgXV
                    grpConnected.Text = "[" + tcpClient.Client.LocalEndPoint + "] ɐڑ";

                    enable = true;
                }
                else
                {
                    // T[o[ؒf
                    close();

                    // {^̖̑̂ɕύX
                    cb.Text = "Connect";

                    // O[v^CgXV
                    grpConnected.Text = "ڑ";
                }

                // eLXg{bNXEnableݒ
                txtHost.Enabled = !enable;
                txtPort.Enabled = !enable;

                // O[vEnableݒ
                grpConnected.Enabled = enable;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                cb.Checked = !cb.Checked;
            }
        }

        /// <summary>
        /// ڑ
        /// </summary>
        private void connect()
        {
            string host = txtHost.Text;
            int port = 0;
            if (!Int32.TryParse(txtPort.Text, out port))
            {
                MessageBox.Show("Portɂ͐͂ĂB");
                return;
            }

            // TCP NCAg𐶐
            tcpClient = new TcpClient();

            // T[o[֐ڑ
            tcpClient.Connect(host, port);
        }

        /// <summary>
        /// ؒf
        /// </summary>
        private void close()
        {
            if (tcpClient == null) return;

            if (tcpClient.Connected == false) return;

            // T[o[ؒf
            tcpClient.Close();

            tcpClient = null;
        }
    }
}
